Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management
Class MBeanServerFactory

    java.lang.Object
      |
      +--javax.management.MBeanServerFactory

public class MBeanServerFactory
extends java.lang.Object

Provides MBean server references. There are no instances of this class.

Since JMX 1.2 this class makes it possible to replace the default MBeanServer implementation. This is done using the `MBeanServerBuilder` class. The class of the initial MBeanServerBuilder to be instantiated can be specified through the javax.management.builder.initial system property. The specified class must be a public subclass of `MBeanServerBuilder`, and must have a public empty constructor.

By default, if no value for that property is specified, an instance of `javax.management.MBeanServerBuilder` is created. Otherwise, the MBeanServerFactory attempts to load the specified class using `Thread.currentThread().getContextClassLoader()`, or if that is null, `Class.forName()`. Then it creates an initial instance of that Class using `Class.newInstance()`. If any checked exception is raised during this process (e.g. `ClassNotFoundException`, `InstantiationException`) the MBeanServerFactory will propagate this exception from within a RuntimeException.

The javax.management.builder.initial system property is consulted every time a new MBeanServer needs to be created, and the class pointed to by that property is loaded. If that class is different from that of the current MBeanServerBuilder, then a new MBeanServerBuilder is created. Otherwise, the MBeanServerFactory may doCreate a new MBeanServerBuilder or reuse the current one.

If the class pointed to by the property cannot be loaded, or does not correspond to a valid subclass of MBeanServerBuilder then an exception is propagated, and no MBeanServer can be created until the javax.management.builder.initial system property is reset to valid value.

The MBeanServerBuilder makes it possible to wrap the MBeanServers returned by the default MBeanServerBuilder implementation, for the purpose of e.g. adding an additional security layer.

Author:
  Young Yang

Method Summary
`static MBeanServer` | `createMBeanServer()` Return a new object implementing the MBeanServer interface with a standard default domain name.
`static MBeanServer` | `createMBeanServer(java.lang.String domain)` Return a new object implementing the `MBeanServer` interface with the specified default domain name.
`static java.util.ArrayList` | `findMBeanServer(java.lang.String agentId)` Return a list of registered MBeanServer objects.
`static ClassLoaderRepository` | `getClassLoaderRepository(MBeanServer mbeanServer)` Return the ClassLoaderRepository used by the given MBeanServer.
`static MBeanServer` | `newMBeanServer()` Return a new object implementing the MBeanServer interface with a standard default domain name, without keeping an internal reference to this new object.
`static MBeanServer` | `newMBeanServer(java.lang.String domain)` Return a new object implementing the MBeanServer interface with the specified default domain name, without keeping an internal reference to this new object.
`static void` | `releaseMBeanServer(MBeanServer mbeanServer)` Remove internal MBeanServerFactory references to a created MBeanServer.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### releaseMBeanServer

    public static void releaseMBeanServer(MBeanServer mbeanServer)

  Remove internal MBeanServerFactory references to a created MBeanServer. This allows the garbage collector to remove the MBeanServer object.
  Parameters:
    `mbeanServer` - the MBeanServer object to remove.
  Throws:
    `java.lang.IllegalArgumentException` - if `mbeanServer` was not generated by one of the `createMBeanServer` methods, or if `releaseMBeanServer` was already called on it.
    `java.lang.SecurityException` - if there is a SecurityManager and the caller's permissions do not include or imply ``MBeanServerPermission`("releaseMBeanServer")`.

### createMBeanServer

    public static MBeanServer createMBeanServer()

  Return a new object implementing the MBeanServer interface with a standard default domain name. The default domain name is used as the domain part in the ObjectName of MBeans when the domain is specified by the user is null.

  The standard default domain name is defined in `ServiceName.DOMAIN`.

  The MBeanServer reference is internally kept. This will allow `findMBeanServer` to return a reference to this MBeanServer object.

  This method is equivalent to `createMBeanServer(null)`.

  Returns:
    the newly created MBeanServer.
  Throws:
    `java.lang.SecurityException` - if there is a SecurityManager and the caller's permissions do not include or imply ``MBeanServerPermission`("createMBeanServer")`.
    `JMRuntimeException` - if the property `javax.management.builder.initial` exists but the class it names cannot be instantiated through a public no-argument constructor; or if the instantiated builder returns null from its `newMBeanServerDelegate` or `newMBeanServer` methods.
    `ClassCastException` - if the property `javax.management.builder.initial` exists and can be instantiated but is not assignment compatible with `MBeanServerBuilder`.

### createMBeanServer

    public static MBeanServer createMBeanServer(java.lang.String domain)

  Return a new object implementing the `MBeanServer` interface with the specified default domain name. The given domain name is used as the domain part in the ObjectName of MBeans when the domain is specified by the user is null.

  The MBeanServer reference is internally kept. This will allow `findMBeanServer` to return a reference to this MBeanServer object.

  Parameters:
    `domain` - the default domain name for the created MBeanServer. This is the value that will be returned by `MBeanServer.getDefaultDomain()`.
  Returns:
    the newly created MBeanServer.
  Throws:
    `java.lang.SecurityException` - if there is a SecurityManager and the caller's permissions do not include or imply ``MBeanServerPermission`("createMBeanServer")`.
    `JMRuntimeException` - if the property `javax.management.builder.initial` exists but the class it names cannot be instantiated through a public no-argument constructor; or if the instantiated builder returns null from its `newMBeanServerDelegate` or `newMBeanServer` methods.
    `ClassCastException` - if the property `javax.management.builder.initial` exists and can be instantiated but is not assignment compatible with `MBeanServerBuilder`.

### newMBeanServer

    public static MBeanServer newMBeanServer()

  Return a new object implementing the MBeanServer interface with a standard default domain name, without keeping an internal reference to this new object. The default domain name is used as the domain part in the ObjectName of MBeans when the domain is specified by the user is null.

  The standard default domain name is defined in `ServiceName.DOMAIN`.

  No reference is kept. `findMBeanServer` will not be able to return a reference to this MBeanServer object, but the garbage collector will be able to remove the MBeanServer object when it is no longer referenced.

  This method is equivalent to `newMBeanServer(null)`.

  Returns:
    the newly created MBeanServer.
  Throws:
    `java.lang.SecurityException` - if there is a SecurityManager and the caller's permissions do not include or imply ``MBeanServerPermission`("newMBeanServer")`.
    `JMRuntimeException` - if the property `javax.management.builder.initial` exists but the class it names cannot be instantiated through a public no-argument constructor; or if the instantiated builder returns null from its `newMBeanServerDelegate` or `newMBeanServer` methods.
    `ClassCastException` - if the property `javax.management.builder.initial` exists and can be instantiated but is not assignment compatible with `MBeanServerBuilder`.

### newMBeanServer

    public static MBeanServer newMBeanServer(java.lang.String domain)

  Return a new object implementing the MBeanServer interface with the specified default domain name, without keeping an internal reference to this new object. The given domain name is used as the domain part in the ObjectName of MBeans when the domain is specified by the user is null.

  No reference is kept. `findMBeanServer` will not be able to return a reference to this MBeanServer object, but the garbage collector will be able to remove the MBeanServer object when it is no longer referenced.

  Parameters:
    `domain` - the default domain name for the created MBeanServer. This is the value that will be returned by `MBeanServer.getDefaultDomain()`.
  Returns:
    the newly created MBeanServer.
  Throws:
    `java.lang.SecurityException` - if there is a SecurityManager and the caller's permissions do not include or imply ``MBeanServerPermission`("newMBeanServer")`.
    `JMRuntimeException` - if the property `javax.management.builder.initial` exists but the class it names cannot be instantiated through a public no-argument constructor; or if the instantiated builder returns null from its `newMBeanServerDelegate` or `newMBeanServer` methods.
    `ClassCastException` - if the property `javax.management.builder.initial` exists and can be instantiated but is not assignment compatible with `MBeanServerBuilder`.

### findMBeanServer

    public static java.util.ArrayList findMBeanServer(java.lang.String agentId)

  Return a list of registered MBeanServer objects. A registered MBeanServer object is one that was created by one of the `createMBeanServer` methods and not subsequently released with `releaseMBeanServer`.

  Parameters:
    `agentId` - The agent identifier of the MBeanServer to retrieve. If this parameter is null, all registered MBeanServers in this JVM are returned. Otherwise, only MBeanServers whose id is equal to `agentId` are returned. The id of an MBeanServer is the `MBeanServerId` attribute of its delegate MBean.
  Returns:
    A list of MBeanServer objects.
  Throws:
    `java.lang.SecurityException` - if there is a SecurityManager and the caller's permissions do not include or imply ``MBeanServerPermission`("findMBeanServer")`.

### getClassLoaderRepository

    public static ClassLoaderRepository getClassLoaderRepository(MBeanServer mbeanServer)

  Return the ClassLoaderRepository used by the given MBeanServer. This method is equivalent to `server.getClassLoaderRepository()`.
  Parameters:
    `mbeanServer` - The MBeanServer under examination. Since JMX 1.2, if `server` is `null`, the result is a `NullPointerException`. This behaviour differs from what was implemented in JMX 1.1 - where the possibility to use `null` was deprecated.
  Returns:
    The Class Loader Repository used by the given MBeanServer.
  Throws:
    `java.lang.SecurityException` - if there is a SecurityManager and the caller's permissions do not include or imply ``MBeanPermission`("getClassLoaderRepository")`.
    `NullPointerException` - if `server` is null.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD